﻿Type=Activity
Version=1.90
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
Sub Process_Globals
	
End Sub
Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim ViewNumber As Int
	Dim SQL1 As SQL
	Dim SortOrder As String
	Dim	CurrentScv, NumberOfScv As Int
	Dim tbhSub2 As TabHost
	Dim scvTabhost(2) As ScrollView
	Dim ResultSales(20), ResultQuantity(20), ResultTotalSales, ResultTotalQuantity As Double
	Dim ResultMaterialSales, ResultMaterialQuantity, ResultInOrderSales, ResultInOrderQuantity As Double
	Dim lblHeight As Float
	Dim Header, Tabel, pnlTotals As Panel
	Dim NumberOfColumns, RowHeight, HeaderRowHeight, ColumnWidth As Int
	Dim HeaderColor, TableColor, FontColor, HeaderFontColor, SubTotalsColor As Int
	Dim TimesClicked, ColumnTurnover, ColumnQuantity As Int
	Dim TotalTurnover, TotalQuantity As String
	Dim FontSize As Float
	Type RowCol (Row As Int, Col As Int)
	Dim SelectedRow, SelectedRowColor As Int
	Dim SQLString, SortString, HeaderText As String
	Dim SelectedCustomer, SelectedFY As String
	Dim SelectedCustomerIndex, SelectedFYIndex As Int
	Dim Cursor1, Cursor2 As Cursor
	Dim RowData(4), TabTitles(20) As String
	Dim AlignColumn(7), HeaderClicked As Boolean
	Dim imgView1 As ImageView
	Dim lblOverview As Label
	Dim btnCustomer As Button
	Dim btnYear As Button
	Dim adtCustomer As AutoCompleteEditText
	Dim CheckBox1 As CheckBox
	Dim pnlSub2 As Panel
	Dim TabViewCreated  As Boolean
	'settings
	NumberOfColumns = 3 'changed in the program when needed
	HeaderColor = Colors.White
	TableColor = Colors.Blue
	FontColor = Colors.White
	SubTotalsColor = Colors.Black 
	HeaderFontColor = Colors.Blue
	SelectedRowColor = Colors.Blue
	RowHeight = 5.2%y
	HeaderRowHeight = 5.2%y 
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Sub2")
	Activity.AddMenuItem("Screenshot", "mnuScreenshot")
	Activity.Title = "Test"
	SQL1.Initialize(File.DirRootExternal, "Test.sqlite", False)
	'Select last financial year
	SelectedFY = Main.YearList.Get(0)
	SelectedFYIndex = 0
	lblOverview.Text = "Overview per Customer"
	btnYear.Text = SelectedFY & " ▼"
	'Set fontsize tabel as button text
	FontSize = btnYear.TextSize
	btnCustomer.Text =  "Start here or press checkbox to select a single customer"
	HeaderClicked = False
	SortOrder = " ASC"
	SQLString = "SELECT DISTINCT CustomerName FROM Figures WHERE SUBSTR(Period,8) = '" & SelectedFY & "' ORDER BY CustomerName ASC"
	Cursor1 = SQL1.ExecQuery(SQLString)
	'Add all customer to list and fill auto-edit-text
	Dim CustomerList As List
	CustomerList.Initialize
	For i = 0 To Cursor1.RowCount - 1
		Cursor1.Position = i
		CustomerList.Add(Cursor1.GetString2(0))
	Next
	adtCustomer.SetItems(CustomerList)
	tbhSub2.Initialize("tbhSub2")
	Activity.AddView(tbhSub2, 0%x, 30.4%y, 100%x, 65%y)
	tbhSub2.Visible = False
	adtCustomer.Visible = False
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	'Back key ends activity
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		Activity.Finish
	End If
End Sub

Sub SetSQLString
	'Set all SQL Strings
	Select Case ViewNumber
	Case 1
		SQLString = "SELECT Period AS 'Month', SUM(SalesTurnover) AS 'Turnover (€)' FROM Figures WHERE ArtGrpNumber = '" & Cursor1.GetString2(0) & "' AND CustomerName = '" & SelectedCustomer & "' AND SUBSTR(Period,8) = '" & SelectedFY & "' GROUP BY Period"
		If HeaderClicked = False Then
			SortString = " ORDER BY Period" 
		Else
			Select Case HeaderText
			Case "Month"
				SortString = " ORDER BY Period"
			Case "Turnover (€)"
				SortString = " ORDER BY SUM(SalesTurnover)"
			End Select
		End If
	Case 2
		SQLString = "SELECT Period AS 'Month', SUM(SalesTurnover) AS 'Turnover (€)' FROM Figures WHERE CustomerName = '" & SelectedCustomer & "' AND SUBSTR(Period,8) = '" & SelectedFY & "' GROUP BY Period"
		If HeaderClicked = False Then
			SortString = " ORDER BY Period" 
		Else
			Select Case HeaderText
			Case "Month"
				SortString = " ORDER BY Period"
			Case "Turnover (€)"
				SortString = " ORDER BY SUM(SalesTurnover)"
			End Select
		End If
	Case 3
		SQLString = "SELECT ArticleNumber AS 'Material', ArticleName AS 'Description', SUM(SalesQuantity) AS 'Quantity', SUM(SalesTurnover) AS 'Turnover (€)' FROM Figures WHERE SUBSTR(Period,8) = '" & SelectedFY & "' AND CustomerName = '" & SelectedCustomer & "' GROUP BY ArticleNumber"
		If HeaderClicked = False Then
			SortString = " ORDER BY ArticleNumber" 
		Else
			Select Case HeaderText
			Case "Material"
				SortString = " ORDER BY ArticleNumber"
			Case "Description"
				SortString = " ORDER BY ArticleName"
			Case "Quantity"
				SortString = " ORDER BY SUM(SalesQuantity)"
			Case "Turnover (€)"
				SortString = " ORDER BY SUM(SalesTurnover)"
			End Select
		End If
	Case 4
		SQLString = "SELECT Period AS 'Month', ArticleNumber AS 'Material', ArticleName AS 'Description', SUM(InOrderQuantity) AS 'Quantity', SUM(InOrderTurnover) AS 'Turnover (€)' FROM Figures WHERE SUBSTR(Period,8) = '" & SelectedFY & "' AND CustomerName = '" & SelectedCustomer & "' GROUP BY ArticleNumber"
		If HeaderClicked = False Then
			SortString = " ORDER BY ArticleNumber" 
		Else
			Select Case HeaderText
			Case "Month"
				SortString = " ORDER BY Period"
			Case "Material"
				SortString = " ORDER BY ArticleNumber"
			Case "Description"
				SortString = " ORDER BY ArticleName"
			Case "Quantity"
				SortString = " ORDER BY SUM(InOrderQuantity)"
			Case "Turnover (€)"
				SortString = " ORDER BY SUM(InOrderTurnover)"
			End Select
		End If
	End Select
	SQLString = SQLString & SortString & SortOrder
End Sub

Sub CreateScrollView
	Dim i, j, k As Int
	Try
		'Show data of every productgroup in seperate tab
		ViewNumber  = 1
		'Check number of Article groups
		SQLString = "SELECT ArtGrpNumber AS 'Article Group', ArtGrpName AS 'Name' From Figures WHERE CustomerName = '" & SelectedCustomer & "' AND SUBSTR(Period,8) = '" & SelectedFY & "' GROUP BY ArtGrpNumber"
		Cursor1 = SQL1.ExecQuery(SQLString)
		If Cursor1.RowCount = 0 Then
			'When there is no group exit sub
			Return False
		End If
		'Create a tab for every article group + 3 extra for Totals, Material and InOrder
		Dim scvTabhost(Cursor1.RowCount + 3) As ScrollView
		NumberOfScv = Cursor1.RowCount
		'Sort Column if Header is clicked
		If HeaderClicked = True Then
			For i = 1 To 3
				DoEvents
			Next
			Dim ct1 As CustomToast
			ct1.Initialize
			ct1.Show("Sorting column...",100,Gravity.TOP,0,0)
			For i = 1 To 3
				DoEvents
			Next
		End If
		'Store sum of turnover for every tab
		Dim ResultSales(NumberOfScv + 3) As Double
		For k = 0 To NumberOfScv - 1
			Cursor1.Position = k
			CurrentScv = k
			scvTabhost(CurrentScv).Initialize(100%y)
			'Add tab
			tbhSub2.AddTab2(Cursor1.GetString2(0) & " " & Cursor1.GetString2(1), scvTabhost(CurrentScv))
			'Store tab titles
			TabTitles(CurrentScv) = Cursor1.GetString2(0) & " " & Cursor1.GetString2(1)
			SetSQLString
			Cursor2 = SQL1.ExecQuery(SQLString)
			NumberOfColumns = Cursor2.ColumnCount
			ColumnWidth = CalcColumnWidth
			Dim ColumnName(NumberOfColumns) As String
			For i = 0 To NumberOfColumns-1
				ColumnName(i) = Cursor2.GetColumnName(i)
			Next 
			SelectedRow = -1
			If CurrentScv = 0 Then
				'add header and set alignment
				Dim HeaderValues(2) As String
				HeaderValues(0) = "Month"
				HeaderValues(1) = "Turnover (€)"
				NumberOfColumns = 2
				ColumnWidth = CalcColumnWidth
				SetAlignment
				SetHeader(HeaderValues)
			End If
			'add rows
			RowHeight = 5.2%y
			ResultSales(CurrentScv) = 0
			'Calculate totals and add rows
			For i = 0 To Cursor2.RowCount - 1
				Dim Col(NumberOfColumns) As String
				Cursor2.Position = i
				For j = 0 To NumberOfColumns - 1
					Col(j) = Cursor2.GetString(ColumnName(j))
					If j = ColumnTurnover Then
						ResultSales(CurrentScv) = ResultSales(CurrentScv) + Col(j)
					End If
				Next
				AddRow(Col)
			Next
			scvTabhost(CurrentScv).Panel.Height = scvTabhost(CurrentScv).Panel.Height + 130dip '-> in the overview the last item is not visible ???? to correct with this line
			Cursor2.Close
		Next
		Cursor1.Close
		Dim SubTotals(2) As String
		SubTotals(0) = ""
		SubTotals(1) = "∑" & NumberFormat2(ResultSales(CurrentScv),1,0,0,False)
		SetTotals(SubTotals)
	Catch
		Log(LastException.Message)
	End Try
End Sub

Sub CreateTotalView
	Dim i, j As Int
	Try
		ViewNumber = 2
		CurrentScv = NumberOfScv
		scvTabhost(CurrentScv).Initialize(100%y)
		tbhSub2.AddTab2("Total", scvTabhost(CurrentScv))
		TabTitles(CurrentScv) = "Total"
		SetSQLString
		Cursor2 = SQL1.ExecQuery(SQLString)
		If Cursor1.RowCount = 0 Then
			Return False
		End If
		NumberOfColumns = Cursor2.ColumnCount
		ColumnWidth = CalcColumnWidth
		Dim ColumnName(NumberOfColumns) As String
		For i = 0 To NumberOfColumns-1
			ColumnName(i) = Cursor2.GetColumnName(i)
		Next 
		SelectedRow = -1
		'set aligment
		SetAlignment
		'add rows
		ColumnTurnover = 1 'Set ColumnTurnover since SetHeader sub is only called once in CreateScrollView Sub
		ResultTotalSales = 0
		RowHeight = 25dip
		For i = 0 To Cursor2.RowCount - 1
			Dim Col(NumberOfColumns) As String
			Cursor2.Position = i
			For j = 0 To NumberOfColumns - 1
				Col(j) = Cursor2.GetString(ColumnName(j))
				If j = ColumnTurnover Then
					ResultTotalSales = ResultTotalSales + Col(j)
				End If
			Next
			AddRow(Col)
		Next
		scvTabhost(CurrentScv).Panel.Height = scvTabhost(CurrentScv).Panel.Height + 130dip '-> in the overview the last item is not visible ???? to correct with this line
		Cursor2.Close
		Cursor1.Close
	Catch
		Log(LastException.Message)
	End Try
End Sub

Sub CreateMaterialView
	Dim i, j As Int
	Try
		ViewNumber = 3
		CurrentScv = NumberOfScv + 1
		scvTabhost(CurrentScv).Initialize(100%y)
		tbhSub2.AddTab2("Material", scvTabhost(CurrentScv))
		TabTitles(CurrentScv) = "Material"
		SetSQLString
		Cursor2 = SQL1.ExecQuery(SQLString)
		If Cursor1.RowCount = 0 Then
			Return False
		End If
		NumberOfColumns = Cursor2.ColumnCount
		ColumnWidth = CalcColumnWidth
		Dim ColumnName(NumberOfColumns) As String
		For i = 0 To NumberOfColumns-1
			ColumnName(i) = Cursor2.GetColumnName(i)
		Next 
		SelectedRow = -1
		'set aligment
		SetAlignment
		'add rows
		RowHeight = 55dip
		ColumnQuantity = 2
		ColumnTurnover = 3
		ResultMaterialQuantity = 0
		ResultMaterialSales = 0
		For i = 0 To Cursor2.RowCount - 1
			Dim Col(NumberOfColumns) As String
			Cursor2.Position = i
			For j = 0 To NumberOfColumns - 1
				Col(j) = Cursor2.GetString(ColumnName(j))
				If j = ColumnQuantity Then
					ResultMaterialQuantity = ResultMaterialQuantity + Col(j)
				End If
				If j = ColumnTurnover Then
					ResultMaterialSales = ResultMaterialSales + Col(j)
				End If
			Next
			AddRow(Col)
		Next
		scvTabhost(CurrentScv).Panel.Height = scvTabhost(CurrentScv).Panel.Height + 130dip'-> in the overview the last item is not visible ???? to correct with this line
		Cursor2.Close
		Cursor1.Close
	Catch
		Log(LastException.Message)
	End Try
End Sub

Sub CreateInOrderView
	Dim i, j As Int
	Try
		ViewNumber = 4
		CurrentScv = NumberOfScv + 2
		scvTabhost(CurrentScv).Initialize(100%y)
		tbhSub2.AddTab2("In Order", scvTabhost(CurrentScv))
		TabTitles(CurrentScv) = "In Order"
		SetSQLString
		Cursor2 = SQL1.ExecQuery(SQLString)
		If Cursor1.RowCount = 0 Then
			Return False
		End If
		NumberOfColumns = Cursor2.ColumnCount
		ColumnWidth = CalcColumnWidth
		Dim ColumnName(NumberOfColumns) As String
		For i = 0 To NumberOfColumns-1
			ColumnName(i) = Cursor2.GetColumnName(i)
		Next 
		SelectedRow = -1
		'set aligment
		SetAlignment
		'add rows
		RowHeight = 55dip
		ResultInOrderQuantity = 0
		ResultInOrderSales = 0
		ColumnQuantity = 3
		ColumnTurnover = 4 'Set ColumnTurnover since SetHeaser sub is only called once
		For i = 0 To Cursor2.RowCount - 1
			Dim Col(NumberOfColumns) As String
			Cursor2.Position = i
			For j = 0 To NumberOfColumns - 1
				Col(j) = Cursor2.GetString(ColumnName(j))
				If j = ColumnQuantity Then
					ResultInOrderQuantity = ResultInOrderQuantity + Col(j)
				End If
				If j = ColumnTurnover Then
					ResultInOrderSales = ResultInOrderSales + Col(j)
				End If
			Next
			If Col(NumberOfColumns - 1) <> 0 AND Col(NumberOfColumns - 2) <> 0 Then
				AddRow(Col)
			End If
		Next
		scvTabhost(CurrentScv).Panel.Height = scvTabhost(CurrentScv).Panel.Height + 130dip'-> in the overview the last item is not visible ???? to correct with this line
		Cursor2.Close
		Cursor1.Close
	Catch
		Log(LastException.Message)
	End Try
End Sub

Sub AddRow(Values() As String)
	Dim i As Int
	If Values.Length <> NumberOfColumns Then
		Log("Wrong number of values.")
		Return
	End If
	Dim lastRow As Int
	lastRow = NumberOfRows
	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("l")
		l.Color = Colors.Blue
		l.Tag=i
		l.Text = Values(i)
		l.TextSize = FontSize
		l.TextColor = FontColor
		If AlignColumn(i) = True Then
			If i = ColumnTurnover Then
				l.Text= NumberFormat2(l.Text,1,0,0,False)
			End If
			l.Gravity = Gravity.RIGHT
		Else
			l.Gravity = Gravity.LEFT
		End If
		Dim rc As RowCol
		rc.Initialize
		rc.Col = i
		rc.Row = lastRow
		l.Tag = rc
		If i = NumberOfColumns - 1 Then
			scvTabhost(CurrentScv).Panel.AddView(l, ColumnWidth * i, (RowHeight * lastRow) + HeaderRowHeight - 1, ColumnWidth-5dip, RowHeight)
		Else
			scvTabhost(CurrentScv).Panel.AddView(l, (ColumnWidth * i), (RowHeight * lastRow) + HeaderRowHeight - 1, ColumnWidth, RowHeight)
		End If
	Next
	scvTabhost(CurrentScv).Panel.Height = NumberOfRows * RowHeight
End Sub

Sub NumberOfRows As Int
	Return scvTabhost(CurrentScv).Panel.NumberOfViews / NumberOfColumns
End Sub

Sub SetHeader(Values() As String)
	Header.Initialize("")
	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("header")
		l.Text = Values(i)
		If l.Text.Contains("(€)") Then
			ColumnTurnover = i
		End If
		If AlignColumn(i) = True Then
			l.Gravity = Gravity.RIGHT
		Else
			l.Gravity = Gravity.LEFT
		End If
		l.TextSize = FontSize
		l.Color = HeaderColor
		l.TextColor = HeaderFontColor
		l.Tag = i
		Header.AddView(l, ColumnWidth * i, 0, ColumnWidth, HeaderRowHeight)
	Next
	Activity.AddView(Header, 0.9%x, 42.2%y, 98%x, HeaderRowHeight)
End Sub

Sub Header_Click
	Dim l As Label
	Dim col As Int
	Dim CurrentTab As Int
	l = Sender
	col = l.Tag
	HeaderText = l.Text
	HeaderClicked = True
	CurrentTab = tbhSub2.CurrentTab
	If CurrentTab = 0 Then
		If SortOrder = " ASC" Then
			SortOrder = " DESC"
		Else
			SortOrder = " ASC"
		End If
	Else
		'Do Nothing
	End If
	ClearAll
	CreateScrollView
	CreateTotalView
	CreateMaterialView
	If SelectedFY >= DateTime.GetYear(DateTime.Now) Then
		CreateInOrderView
	End If
	tbhSub2.CurrentTab = CurrentTab
	HeaderClicked = False
End Sub

Sub ClearAll
	RemoveHeader
	tbhSub2.RemoveView
	tbhSub2.Initialize("tbhSub2")
	Activity.AddView(tbhSub2, 0%x, 30.4%y, 100%x, 65%y)
	For j = 0 To NumberOfScv-1
		For i = scvTabhost(j).Panel.NumberOfViews -1 To 0 Step -1
			scvTabhost(j).Panel.RemoveViewAt(i)
		Next
		scvTabhost(j).Panel.Height = 0
		scvTabhost(j).Initialize(100%y)
		SelectedRow = -1
	Next
End Sub

Sub RemoveHeader
	Try
		Dim i As Int
		For i = Header.NumberOfViews - 1 To 0 Step -1
			Header.RemoveViewAt(i)
		Next
		Header.RemoveView
	Catch
	End Try
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
		
End Sub

Sub tbhSub2_TabChanged
	If TabViewCreated = False Then
		'Don't enter this sub before complete tab has been filled
		Return False
	End If
	RemoveHeader
	Select Case TabTitles(tbhSub2.CurrentTab)
	Case "Total"
		Dim HeaderValues(2) As String
		HeaderValues(0) = "Month"
		HeaderValues(1) = "Turnover (€)"
		NumberOfColumns = 2
		ColumnWidth = CalcColumnWidth
		ViewNumber = 2
		SetAlignment
		SetHeader(HeaderValues)
		Dim SubTotals(2) As String
		SubTotals(0) = ""
		SubTotals(1) = "∑" & NumberFormat2(ResultTotalSales,1,0,0,False)
		SetTotals(SubTotals)
	Case "Material"
		Dim HeaderValues(4) As String
		HeaderValues(0) = "Material"
		HeaderValues(1) = "Description"
		HeaderValues(2) = "Quantity"
		HeaderValues(3) = "Turnover (€)"
		NumberOfColumns = 4
		ColumnWidth = CalcColumnWidth
		ViewNumber = 3
		SetAlignment
		SetHeader(HeaderValues)
		Dim SubTotals(4) As String
		For i = 0 To 1
			SubTotals(i) = ""
		Next
		SubTotals(2) = "∑" & NumberFormat2(ResultMaterialQuantity,1,0,0,False)
		SubTotals(3) = "∑" & NumberFormat2(ResultMaterialSales,1,0,0,False)
		SetTotals(SubTotals)
	Case "In Order"
		Dim HeaderValues(5) As String
		HeaderValues(0) = "Month"
		HeaderValues(1) = "Material"
		HeaderValues(2) = "Description"
		HeaderValues(3) = "Quantity"
		HeaderValues(4) = "Turnover (€)"
		NumberOfColumns = 5
		ColumnWidth = CalcColumnWidth
		ViewNumber = 4
		SetAlignment
		SetHeader(HeaderValues)
		Dim SubTotals(5) As String
		For i = 0 To 2
			SubTotals(i) = ""
		Next
		SubTotals(3) = "∑" & NumberFormat2(ResultInOrderQuantity,1,0,0,False)
		SubTotals(4) = "∑" & NumberFormat2(ResultInOrderSales,1,0,0,False)
		SetTotals(SubTotals)
	Case Else
		Dim HeaderValues(2) As String
		HeaderValues(0) = "Month"
		HeaderValues(1) = "Turnover (€)"
		NumberOfColumns = 2
		ColumnWidth = CalcColumnWidth
		ViewNumber = 1
		SetAlignment
		SetHeader(HeaderValues)
		Dim SubTotals(2) As String
		SubTotals(0) = ""
		SubTotals(1) = "∑" & NumberFormat2(ResultSales(tbhSub2.CurrentTab),1,0,0,False)
		SetTotals(SubTotals)
	End Select
	If SortOrder = " ASC" Then
		SortOrder = " DESC"
	Else
		SortOrder = " ASC"
	End If
End Sub

Sub imgView1_Click
	Activity_KeyPress (KeyCodes.KEYCODE_BACK)
End Sub

Sub imgView1_LongClick
	Activity.Finish
End Sub

Sub SetAlignment
	Dim AlignColumn(NumberOfColumns) As Boolean
	Dim i As Int
	'Reset all values
	For i = 0 To NumberOfColumns-1
		AlignColumn(i) = False
	Next 
	'Set values > True means alignment right
	Select Case ViewNumber
	Case 1,2
		AlignColumn(1) = True
	Case 3
		AlignColumn(2) = True
		AlignColumn(3) = True
	Case 4
		AlignColumn(3) = True
		AlignColumn(4) = True
	End Select
End Sub

Sub SetTotals(Values() As String)
	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("pnlTotals")
		l.Text = Values(i)
		l.Gravity = Gravity.RIGHT
		l.TextSize = FontSize
		l.Color = SubTotalsColor
		l.TextColor = FontColor
		l.Tag = i
		pnlTotals.AddView(l, ColumnWidth * i, 0, ColumnWidth-5dip, HeaderRowHeight)
	Next
End Sub

Sub btnYear_Click
	Dim Result1 As Int
	Result1 = InputList(Main.YearList, "Select Financial Year", SelectedFYIndex)
	If Result1 < 0  Then
		Return False
	End If
	TabViewCreated = False
	SelectedFY = Main.YearList.Get(Result1)
	SelectedFYIndex = Result1
	SQLString = "SELECT DISTINCT CustomerName FROM Figures WHERE SUBSTR(Period,8) = '" & SelectedFY & "' ORDER BY CustomerName ASC"
	Cursor1 = SQL1.ExecQuery(SQLString)
	Dim CustomerList As List
	CustomerList.Initialize
	For i = 0 To Cursor1.RowCount - 1
		Cursor1.Position = i
		CustomerList.Add(Cursor1.GetString2(0))
	Next
	adtCustomer.SetItems(CustomerList)
	btnYear.Text = SelectedFY & " ▼"
	FillTab
End Sub

Sub btnCustomer_Click
	TabViewCreated = False
	SQLString = "SELECT DISTINCT CustomerName FROM Figures WHERE SUBSTR(Period,8) = '" & SelectedFY & "' ORDER BY CustomerName ASC"
	Cursor1 = SQL1.ExecQuery(SQLString)
	Dim Result1 As Int
	Dim Lst1 As List
	Lst1.Initialize
	For i = 0 To Cursor1.RowCount - 1
		Cursor1.Position = i
		Lst1.Add(Cursor1.GetString2(0))
		If adtCustomer.Text = Cursor1.GetString2(0) Then	
			SelectedCustomerIndex = Cursor1.Position
		End If
	Next
	Result1 = InputList(Lst1, "Select Customer", SelectedCustomerIndex)
	If Result1 < 0  Then
		Return False
	End If
	SelectedCustomer = Lst1.Get(Result1)
	SelectedCustomerIndex = Result1
	FillTab
End Sub

Sub FillTab
	ProgressDialogShow(Main.WaitText)
	For i = 1 To 3
		DoEvents
	Next
	lblOverview.Text = "Overview per Customer (" & SelectedCustomer & ")"
	ClearAll
	CreateScrollView
	CreateTotalView
	CreateMaterialView
	If SelectedFY >= DateTime.GetYear(DateTime.Now) Then
		CreateInOrderView
	End If
	TabViewCreated = True
	tbhSub2.CurrentTab = NumberOfScv
	If CheckBox1.Checked = True Then
		adtCustomer.Text = ""
	End If
	ProgressDialogHide
End Sub

Sub CheckBox1_CheckedChange(Checked As Boolean)
	If Checked = False Then
		adtCustomer.Visible = False
		adtCustomer.SendToBack
		btnCustomer.Visible = True
		btnCustomer.BringToFront
	Else
		btnCustomer.Visible = False
		btnCustomer.SendToBack
		adtCustomer.Visible = True
		adtCustomer.BringToFront
		adtCustomer.RequestFocus
	End If
End Sub

Sub adtCustomer_ItemClick (Value As String)
	TabViewCreated = False
	SelectedCustomer = adtCustomer.Text
	FillTab
End Sub

Sub CalcColumnWidth As Int
	Return 97.6%x / NumberOfColumns
End Sub

Sub mnuScreenshot_Click
	Activity.CloseMenu
	PrintScreen.TakeShot
End Sub
